#include <MultiThreading/Task.h>
#include <MultiThreading/Thread.h>
#include <MultiThreading/ThreadPool.h>

#include <iostream>

using namespace MultiThreading;
using namespace std::chrono_literals;

int32_t some_test_func(int32_t hello) {
    for (unsigned int i = 0; i < 1000; i++)
        std::this_thread::sleep_for(1ms);
    return hello;
}

/*
int main() {
    // Each task you create can be run by a thread only once. It's marked as complete after.
    // If you're running a lambda or std::function directly on the thread, It can be used multiple times.
    int32_t a = 0;
    auto some_task = Task<int32_t>::Create([] { return some_test_func(4); }, &a);

    // You can start threads in place like this, but you have to wait for the amount of time
    // it takes for the thread to start up which in many cases is longer than the job. Use thread pool.
    Thread some_thread;
    some_thread.SetTask(some_task);

    // Some work running concurrently with the worker thread.
    //for (unsigned int i = 0; i < 10; i++) {}

    // When we get to the point in our code where we need the result from the task wait until it's finished.
    //while (!some_task->Complete()) {}


    //std::cout << a << std::endl;
    std::cout << "Primarch Thread Complete" << std::endl;

    return 0;
}
*/



int main() {
    ThreadPool thread_pool(1);

    auto some_task_1 = Task<void>::Create(([] { return some_test_func(1); }));
    auto some_task_2 = Task<void>::Create(([] { return some_test_func(1); }));
    auto some_task_3 = Task<void>::Create(([] { return some_test_func(1); }));
    auto some_task_4 = Task<void>::Create(([] { return some_test_func(1); }));

    thread_pool.Enqueue(some_task_1);
    thread_pool.Enqueue(some_task_2);
    thread_pool.Enqueue(some_task_3);
    thread_pool.Enqueue(some_task_4);

    while (!some_task_4->Complete()) {}
    std::cout << "qty" << thread_pool.ThreadCount() << std::endl;

    //delete thread_pool;
}
